#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 100005;

struct node
{
    int cnt_div;
    long long pref, suff;
    long long par0, par1;
};

int n, q;
int pos[MAXN];
node tree[4 * MAXN];
bool d[MAXN];

inline node combine(int mid, node lpart, node rpart)
{
    node whole;
    whole.cnt_div = lpart.cnt_div + rpart.cnt_div;
    if (d[mid]) whole.cnt_div++;

    if (!d[mid] and lpart.cnt_div == 0) whole.pref = max(lpart.pref, rpart.pref);
    else whole.pref = lpart.pref;
    if (!d[mid] and rpart.cnt_div == 0) whole.suff = max(rpart.suff, lpart.suff);
    else whole.suff = rpart.suff;

    if (d[mid])
    {
        if (lpart.cnt_div & 1) // Lpref, Lpar1, ..., Lpar0, Lsuff, Rpref, Rpar1, Rpar0, ...
        {
            whole.par1 = lpart.par1 + lpart.suff + rpart.par1;
            whole.par0 = lpart.par0 + (rpart.cnt_div != 0) * rpart.pref + rpart.par0;
        }
        else // Lpref, Lpar1, ..., Lpar1, Lsuff, Rpref, Rpar1, Rpar0, ...
        {
            whole.par0 = lpart.par0 + (lpart.cnt_div != 0) * lpart.suff + rpart.par1;
            whole.par1 = lpart.par1 + (rpart.cnt_div != 0) * rpart.pref + rpart.par0;
        }
    }
    else
    {
        if (lpart.cnt_div & 1) // Lpref, Lpar1, ..., Lpar0, Mpart, Rpar1, Rpar0, ...
        {
            whole.par1 = lpart.par1 + rpart.par0 + (rpart.cnt_div != 0) * max(lpart.suff, rpart.pref);
            whole.par0 = lpart.par0 + rpart.par1;
        }
        else // Lpref, Lpar1, ..., Lpar1, Mpart, Rpar1, Rpar0, ...
        {
            whole.par0 = lpart.par0 + rpart.par0 + (lpart.cnt_div != 0 and rpart.cnt_div != 0) * max(lpart.suff, rpart.pref);
            whole.par1 = lpart.par1 + rpart.par1;
        }
    }

    return whole;
}

void build(int v = 1, int l = 1, int r = n)
{
    if (l == r)
    {
        tree[v].cnt_div = 0;
        tree[v].pref = tree[v].suff = 0;
        tree[v].par0 = tree[v].par1 = 0;
        pos[l] = v;
        return;
    }

    int mid = (l + r) >> 1;
    build(v << 1 | 0, l, mid + 0);
    build(v << 1 | 1, mid + 1, r);
}

int idx, ql, qr;

void update(int v = 1, int l = 1, int r = n)
{
    if (idx < l or idx > r) return;
    if (l == idx and r == idx) return;

    int mid = (l + r) >> 1;
    update(v << 1 | 0, l, mid + 0);
    update(v << 1 | 1, mid + 1, r);

    tree[v] = combine(mid, tree[v << 1 | 0], tree[v << 1 | 1]);
}

node query(int v = 1, int l = 1, int r = n)
{
    if (ql <= l and r <= qr) return tree[v];
    if (qr < l or r < ql) return {-1, 0, 0, 0, 0};

    int mid = (l + r) >> 1;
    node lpart = query(v << 1 | 0, l, mid + 0);
    node rpart = query(v << 1 | 1, mid + 1, r);

    if (lpart.cnt_div == -1) return rpart;
    if (rpart.cnt_div == -1) return lpart;
    return combine(mid, lpart, rpart);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    build();

    cin >> q;
    for (int i = 1; i <= q; ++ i)
    {
        int t, l, r, add;
        cin >> t;
        if (t == 1 or t == 2)
        {
            cin >> idx;
            d[idx] ^= 1;
            update();
        }
        if (t == 3)
        {
            cin >> idx >> add;
            tree[pos[idx]].pref += add;
            tree[pos[idx]].suff += add;
            update();
        }
        if (t == 4)
        {
            cin >> l >> r;
            ql = 1; qr = l;
            int cnt = query().cnt_div;

            ql = l; qr = r;
            auto res = query();
            long long ans = 0;
            if (cnt & 1) // pref is odd
            {
                ans = res.pref + res.par0;
                if ((res.cnt_div & 1) == 0 and res.cnt_div != 0) ans += res.suff;
            }
            else // pref is even
            {
                ans = res.par1;
                if ((res.cnt_div & 1) != 0) ans += res.suff;
            }
            cout << ans << endl;
        }
    }

    return 0;
}
// :)
