#include<bits/stdc++.h>
using namespace std;

const int maxn = 1e5+2;
int n, q, cntp[4*maxn], nextp[maxn], prp[maxn], lazy[4*maxn], p[4*maxn];
long long tree[4*maxn];

void push_lazy(int i, int l, int r)
{
    if (lazy[i])
    {
        if (l != r)
        {
            lazy[2*i] = lazy[i];
            lazy[2*i+1] = lazy[i];
        }
        p[i] = lazy[i];
        lazy[i] = 0;
    }
}

void update_pos(int i, int l, int r, int ql, int qr, int val)
{
    push_lazy(i, l, r);
    if (r < ql || l > qr) return;
    if (ql <= l && r <= qr)
    {
        lazy[i] = val;
        push_lazy(i, l, r);
        return;
    }
    int mid = (l+r) >> 1;
    update_pos(2*i, l, mid, ql, qr, val);
    update_pos(2*i+1, mid+1, r, ql, qr, val);
}

int query_pos(int i, int l, int r, int pos)
{
    push_lazy(i, l, r);
    if (l == r)
    {
        return p[i];
    }
    int mid = (l+r) >> 1;
    if (pos <= mid) return query_pos(2*i, l, mid, pos);
    else return query_pos(2*i+1, mid+1, r, pos);
}



void update_p(int i, int l, int r, int pos, int val)
{
    if (l == r)
    {
        cntp[i] += val;
        return;
    }
    int mid = (l+r) >> 1;
    if (pos <= mid) update_p(2*i, l, mid, pos, val);
    else update_p(2*i+1, mid+1, r, pos, val);
    cntp[i] = cntp[2*i] + cntp[2*i+1];
}

int query_p(int i, int l, int r, int ql, int qr)
{
    if (r < ql || l > qr) return 0;
    if (l >= ql && r <= qr) return cntp[i];
    int mid = (l+r) >> 1;
    return (query_p(2*i, l, mid, ql, qr) + query_p(2*i+1, mid+1, r, ql, qr));
}



void update_res(int i, int l, int r, int pos, int val)
{
    if (l == r)
    {
        tree[i] += val;
        return;
    }
    int mid = (l+r) >> 1;
    if (pos <= mid) update_res(2*i, l, mid, pos, val);
    else update_res(2*i+1, mid+1, r, pos, val);
    tree[i] = max(tree[2*i], tree[2*i+1]);
}

long long query_max(int i, int l, int r, int ql, int qr)
{
    if (r < ql || l > qr) return 0;
    if (l >= ql && r <= qr) return tree[i];
    int mid = (l+r) >> 1;
    return max(query_max(2*i, l, mid, ql, qr), query_max(2*i+1, mid+1, r, ql, qr));
}

void read_solve()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> q ;

    int i;
    for (i=1; i<=n; ++i)
    {
        prp[i] = 0;
        nextp[i] = n;
    }
    update_p(1, 1, n, n, 1);
    update_pos(1, 1, n, 1, n, n);

    int type, pos, n1, n2, val, br, l, r;
    long long ans ;
    for (i=1; i<=q; ++i)
    {
        cin >> type ;
        if (type == 1)
        {
            cin >> pos ;
            n2 = query_pos(1, 1, n, pos);
            n1 = prp[n2];
            update_pos(1, 1, n, n1+1, pos, pos);
            nextp[n1] = pos;
            nextp[pos] = n2;
            prp[n2] = pos;
            prp[pos] = n1;
            update_p(1, 1, n, pos, 1);
            //cout << n1 << " -> " << pos <<  " -> " << n2 << '\n';
        }
        if (type == 2)
        {
            cin >> pos ;
            n2 = nextp[pos];
            n1 = prp[pos];
            update_pos(1, 1, n, n1+1, pos, n2);
            nextp[pos] = 0;
            prp[pos] = 0;
            nextp[n1] = n2;
            prp[n2] = n1;
            update_p(1, 1, n, pos, -1);
            //cout << n1 << " -> " << pos <<  " -> " << n2 << '\n';
        }
        if (type == 3)
        {
            cin >> pos >> val ;
            update_res(1, 1, n, pos, val);
        }
        if (type == 4)
        {
            cin >> l >> r ;
            if (l == 1) br = 0;
            else br = query_p(1, 1, n, 1, l-1);

            //cout << "*"<< br << '\n' << '\n' ;

            ans = 0;
            n2 = query_pos(1, 1, n, l);
            //cout << "**"<< n2 << '\n';
            if (n2 > r)
                n2 = r;
            //cout << "**"<<  n2 << '\n' ;
            if (br&1)
            {
                ans += query_max(1, 1, n, l, n2);
                //cout << l << " - " << n2 << " " << ans << '\n' ;
                if (n2 == r)
                {
                    cout << ans << '\n' ;
                    continue;
                }

                while (true)
                {
                    n2 = nextp[n2];
                    if (n2 == n)
                    {
                        cout << ans << '\n' ;
                        break;
                    }

                    n1 = n2 + 1;
                    n2 = nextp[n2];
                    if (n2 > r)
                        n2 = r;
                    ans += query_max(1, 1, n, n1, n2);
                    //cout << n1 << " - " << n2 << " " << ans << '\n' ;
                    if (n2 == r)
                    {
                        cout << ans << '\n' ;
                        break;
                    }
                }
            }
            else
            {
                if (n2 == r)
                {
                    cout << ans << '\n' ;
                    continue;
                }
                n1 = n2 + 1;
                n2 = nextp[n2];
                if (n2 > r)
                    n2 = r;
                ans += query_max(1, 1, n, n1, n2);
                //cout << n1 << " - " << n2 << " " << ans << '\n' ;
                if (n2 == r)
                {
                    cout << ans << '\n' ;
                    continue;
                }

                while (true)
                {
                    n2 = nextp[n2];
                    if (n2 == n)
                    {
                        cout << ans << '\n' ;
                        break;
                    }

                    n1 = n2 + 1;
                    n2 = nextp[n2];
                    if (n2 > r)
                        n2 = r;
                    ans += query_max(1, 1, n, n1, n2);
                    cout << n1 << " - " << n2 << " " << ans << '\n' ;
                    if (n2 == r)
                    {
                        cout << ans << '\n' ;
                        break;
                    }
                }
            }
        }
    }
}

int main()
{
    read_solve();
    return 0;
}