#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
}

struct node
{
    ll sum_odd, sum_even;
    ll max_left, max_right;
    int split;
    int right_split;
    int dividers;

    node(ll _sum_odd = 0, ll _sum_even = 0, ll _max_left = 0, ll _max_right = 0,
         int _split = 0, int _right_split = 0, int _dividers = 0)
    {
        sum_odd = _sum_odd;
        sum_even = _sum_even;
        max_left = _max_left;
        max_right = _max_right;
        split = _split;
        right_split = _right_split;
        dividers = _dividers;
    }
};

node merge_nodes(node lf, node rf)
{
    if (lf.split == -1)
        return rf;
    if (rf.split == -1)
        return lf;

    node mf;

    if (lf.right_split)
    {
        mf.split = 1;
        mf.right_split = rf.right_split;
        mf.max_left = lf.max_left;
        mf.max_right = rf.max_right;
        mf.sum_odd = lf.sum_odd;
        mf.sum_even = lf.sum_even;
        if ((lf.dividers + 1) % 2 == 0)
        {
            mf.sum_odd += rf.sum_odd;
            mf.sum_even += rf.sum_even;
        }
        else
        {
            mf.sum_even += rf.sum_odd;
            mf.sum_odd += rf.sum_even;
        }

        mf.dividers = lf.dividers + rf.dividers + 1;
    }
    else
    {
        if (lf.dividers % 2 == 0)
            lf.sum_odd -= lf.max_right;
        else
            lf.sum_even -= lf.max_right;
        rf.sum_odd += max((ll)(0), lf.max_right - rf.max_left);

        mf.split = max(lf.split, rf.split);
        mf.right_split = rf.right_split;
        mf.sum_odd = lf.sum_odd;
        mf.sum_even = lf.sum_even;
        if ((lf.dividers) % 2 == 0)
        {
            mf.sum_odd += rf.sum_odd;
            mf.sum_even += rf.sum_even;
        }
        else
        {
            mf.sum_even += rf.sum_odd;
            mf.sum_odd += rf.sum_even;
        }

        if (lf.split == 0)
            mf.max_left = max(lf.max_left, rf.max_left);
        else
            mf.max_left = lf.max_left;

        if (rf.split == 0)
            mf.max_right = max(lf.max_right, rf.max_right);
        else
            mf.max_right = rf.max_right;

        mf.dividers = lf.dividers + rf.dividers;

    }
    return mf;
}

const int maxn = 1e5 + 10;
node tree[4 * maxn];
void flip(int root, int left, int right, int pos)
{
    if (left == right)
    {
        tree[root].right_split = (tree[root].right_split + 1) % 2;
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        flip(root * 2, left, mid, pos);
    else
        flip(root * 2 + 1, mid + 1, right, pos);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}

void update(int root, int left, int right, int pos, ll val)
{
    if (left == right)
    {
        tree[root].max_left += val;
        tree[root].max_right += val;
        tree[root].sum_odd += val;
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        update(root * 2, left, mid, pos, val);
    else
        update(root * 2 + 1, mid + 1, right, pos, val);

    tree[root] = merge_nodes(tree[root * 2], tree[root * 2 + 1]);
}

node query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
    {
        node et;
        et.split = -1;
        return et;
    }

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return merge_nodes(query(root * 2, left, mid, qleft, qright),
                    query(root * 2 + 1, mid + 1, right, qleft, qright));

}

int n, q;
int sp[maxn], fen[maxn];

void update_fen(int pos)
{
    int val = 1;
    if (sp[pos] == 1)
        val = -1;
    sp[pos] = (sp[pos] + 1) % 2;
    for (int i = pos; i <= n; i += (i & -i))
        fen[i] += val;
}

int sum(int pos)
{
    int s = 0;
    for (int i = pos; i > 0; i -= (i & -i))
        s += fen[i];
    return s;
}

void solve()
{
    cin >> n >> q;
    for (int i = 1; i <= q; i ++)
    {
        int type;
        cin >> type;
        if (type == 1 || type == 2)
        {
            int p;
            cin >> p;
            /// flip position p
            flip(1, 1, n, p);
            update_fen(p);
        }
        else
        if (type == 3)
        {
            int idx;
            ll val;
            cin >> idx >> val;
            /// update index with value
            update(1, 1, n, idx, val);
        }
        else
        {
            int l, r;
            cin >> l >> r;
            /// query interval l, r
            node cur = query(1, 1, n, l, r);
            int bef = sum(l - 1);
            if (bef % 2 == 0)
                cout << cur.sum_even << endl;
            else
                cout << cur.sum_odd << endl;
        }

    }

}

int main()
{
   speed();
    solve();
	return 0;
}
