#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5+5;

long long tree[4 * MAXN];
long long a[MAXN];
bool p[MAXN];
int n;

void update(int L, int R, int node, int pos, int val)
{
    if (pos < L || pos > R) return;
    if (L == pos && R == pos)
    {
        tree[node] += val;
        return;
    }
    int m = (L+R)/2;
    update(L, m, node*2, pos, val);
    update(m+1, R, node*2+1, pos, val);
    tree[node] = tree[node*2] + tree[node*2+1];
}

long long query(int L, int R, int node, int beg, int en)
{
    if (L > en || R < beg) return 0;
    if (L >= beg && R <= en) return tree[node];
    int m = (L+R)/2;
    return query(L, m, node*2, beg, en) + query(m+1, R, node*2+1, beg, en);
}

long long query2(int L, int R)
{
    long long ret = 0;
    long long maxx = 0;
    int curr = 0;
    curr = query(1, n, 1, 1, L) % 2;
    for (int i = L; i <= R; i++)
    {
        maxx = max(maxx, a[i]);
        if (p[i] && p[i] == curr) ret += maxx;
        if (p[i])
        {
            maxx = 0;
            curr ^= 1;
        }
    }
    if (p[R] != curr) ret += maxx;
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int q;
    cin >> n >> q;

    p[n] = 1;
    for (int i = 0; i < q; i++)
    {
        int t; cin >> t;
        if (t == 1)
        {
            int x; cin >> x;
            update(1, n, 1, x+1, 1);
            p[x] ^= 1;
        }
        else if (t == 2)
        {
            int x; cin >> x;
            update(1, n, 1, x+1, -1);
            p[x] ^= 1;
        }
        else if (t == 3)
        {
            int x, y; cin >> x >> y;
            a[x] += y;
        }
        else
        {
            int L, R; cin >> L >> R;
            if (L == R) cout << (query(1, n, 1, 1, R) & 1 ? a[R] : 0)<< endl;
            else cout << query2(L, R) << endl;
        }
    }

    return 0;
}
/**
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 6
1 1
4 3 6
3 10 3
3 9 2
3 8 9
1 8
4 1 10
4 4 9
3 9 8
1 7
3 2 6
4 2 9
2 1
4 2 9

*/
