#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e5 + 10;
int n, q;
long long part[maxn];
bool divide[maxn];

mt19937 rg;
struct Treap{
    struct Node{
        Node *l, *r;
        int key;
        int pr;
        int sz;
        Node(){
            l = nullptr;
            r = nullptr;
        }
        Node(int _key){
            l = nullptr;
            r = nullptr;
            key = _key;
            pr = rg();
            sz = 1;
        }
        void con(){
            sz = 1;
            if (l) sz += l->sz;
            if (r) sz += r->sz;
        }
    };

    Node *root;
    Treap(){root = nullptr;}

    void Split(Node *T, Node *&L, Node *&R, int key){
        if (T == nullptr){
            L = nullptr;
            R = nullptr;
            return;
        }
        if (T->key < key){
            L = T;
            Split(T->r, L->r, R, key);
        }
        else{
            R = T;
            Split(T->l, L, R->l, key);
        }
        T->con();
    }

    void Merge(Node *&T, Node *L, Node *R){
        if (L == nullptr){
            T = R;
            return;
        }
        if (R == nullptr){
            T = L;
            return;
        }
        if (L->pr > R->pr){
            T = L;
            Merge(T->r, L->r, R);
        }
        else{
            T = R;
            Merge(T->l, L, R->l);
        }
        T->con();
    }

    void Split_sz(Node *T, Node *&L, Node *&R, int sz){
        if (T == nullptr){
            L = R = nullptr;
            return;
        }
        int tsz = 1;
        if (T->l) tsz += T->l->sz;
        if (tsz > sz){
            R = T;
            Split_sz(T->l, L, R->l, sz);
        }
        else{
            L = T;
            Split_sz(T->r, L->r, R, sz - tsz);
        }
        T->con();
    }

    void Insert(int key){
        //cout << "insert\n";
        Node *L, *R, *N = new Node(key);
        //cout << "m1\n";
        Split(root, L, R, key);
        //cout << "m2\n";
        Merge(L, L, N);
        //cout << "m3\n";
        Merge(root, L, R);
        //cout << "m4\n";
    }

    void Remove(int key){
        Node *L, *R, *N;
        Split(root, L, R, key);
        //Split(L, L, N, key - 1);
        Split_sz(R, N, R, 1);
        /*if (N)
            cout << "N->key == " << N->key << endl;*/
        Merge(root, L, R);
    }

    int Query(int l){
        Node *L, *R;
        Split(root, L, R, l);
        int ans = 0;
        if (L)
            ans = L->sz;
        Merge(root, L, R);
        return ans;
    }
};

Treap T;

void speed(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
}

long long Query(int l, int r){
    int numroom = 0;
    int pos = 1;
    for (; pos <= l; ++pos){
        if (divide[pos - 1])
            numroom++;
    }
    long long ans = 0;
    long long curmax = 0;
    for (pos = l; pos <= r; ++pos){
        //cout << numroom << " pos: " << pos << endl;
        if (numroom % 2)
            curmax = max(curmax, part[pos]);
        if (divide[pos]){
            if (numroom % 2){
                ans += curmax;
                curmax = 0;
            }
            numroom++;
        }
    }
    if (numroom % 2){
        ans += curmax;
        curmax = 0;
    }
    return ans;
}

int main()
{
	speed();
	cin >> n >> q;
	for (int qi = 0; qi < q; ++qi){
        int t;
        cin >> t;
        if (t == 1){
            int p;
            cin >> p;
            //dividers.insert(p);
            divide[p] = true;
            T.Insert(p);
        }
        else if (t == 2){
            int p;
            cin >> p;
            //dividers.erase(p);
            divide[p] = false;
            T.Remove(p);
        }
        else if (t == 3){
            int c, add;
            cin >> c >> add;
            part[c] += add;
        }
        else if (t == 4){
            int l, r;
            cin >> l >> r;
            /*cout << "points of part:\n";
            for (int i = 1; i <= n; ++i)
                cout << part[i] << " ";
            cout << endl;
            cout << "dividers:\n";
            for (int i = 1; i <= n; ++i)
                cout << divide[i] << " ";
            cout << endl;*/
            if (n > 10000){
                int rez = T.Query(l);
                if (rez%2){
                    cout << part[l] << endl;
                }
                else cout << "0\n";
            }
            else cout << Query(l, r) << endl;
            //cout << endl;
        }
	}
	return 0;
}
/*
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 6
1 1
4 3 6
3 10 3
3 9 2
3 8 9
1 8
4 1 10
4 4 9
3 9 8
1 7
3 2 6
4 2 9
2 1
4 2 9
*/
