#include<bits/stdc++.h>
using namespace std;
const int maxn = (1<<17);
int n, q;
long long part[maxn];
bool divide[maxn];

mt19937 rg;
struct Treap{
    struct Node{
        Node *l, *r;
        int key;
        int pr;
        int sz;
        Node(){
            l = nullptr;
            r = nullptr;
        }
        Node(int _key){
            l = nullptr;
            r = nullptr;
            key = _key;
            pr = rg();
            sz = 1;
        }
        void con(){
            sz = 1;
            if (l) sz += l->sz;
            if (r) sz += r->sz;
        }
    };

    Node *root;
    Treap(){root = nullptr;}

    void Split(Node *T, Node *&L, Node *&R, int key){
        if (T == nullptr){
            L = nullptr;
            R = nullptr;
            return;
        }
        if (T->key < key){
            L = T;
            Split(T->r, L->r, R, key);
        }
        else{
            R = T;
            Split(T->l, L, R->l, key);
        }
        T->con();
    }

    void Merge(Node *&T, Node *L, Node *R){
        if (L == nullptr){
            T = R;
            return;
        }
        if (R == nullptr){
            T = L;
            return;
        }
        if (L->pr > R->pr){
            T = L;
            Merge(T->r, L->r, R);
        }
        else{
            T = R;
            Merge(T->l, L, R->l);
        }
        T->con();
    }

    void Split_sz(Node *T, Node *&L, Node *&R, int sz){
        if (T == nullptr){
            L = R = nullptr;
            return;
        }
        int tsz = 1;
        if (T->l) tsz += T->l->sz;
        if (tsz > sz){
            R = T;
            Split_sz(T->l, L, R->l, sz);
        }
        else{
            L = T;
            Split_sz(T->r, L->r, R, sz - tsz);
        }
        T->con();
    }

    void Insert(int key){
        //cout << "insert\n";
        Node *L, *R, *N = new Node(key);
        //cout << "m1\n";
        Split(root, L, R, key);
        //cout << "m2\n";
        Merge(L, L, N);
        //cout << "m3\n";
        Merge(root, L, R);
        //cout << "m4\n";
    }

    void Remove(int key){
        Node *L, *R, *N;
        Split(root, L, R, key);
        //Split(L, L, N, key - 1);
        Split_sz(R, N, R, 1);
        /*if (N)
            cout << "N->key == " << N->key << endl;*/
        Merge(root, L, R);
    }

    int Query(int l){
        Node *L, *R;
        Split(root, L, R, l);
        int ans = 0;
        if (L)
            ans = L->sz;
        Merge(root, L, R);
        return ans;
    }

    bool is_even_room(int l, int r){
        assert(l <= r);
        Node *L, *R;
        Split(root, L, R, l);
        int rooml = 0;
        if (L)
            rooml = L->sz;
        Merge(root, L, R);
        Split(root, L, R, r);
        int roomr = 0;
        if (L)
            roomr = L->sz;
        Merge(root, L, R);
        if (rooml == roomr && rooml % 2 == 0)
            return true;
        else return false;
    }

    bool is_odd_room(int l, int r){
        assert(l <= r);
        Node *L, *R;
        Split(root, L, R, l);
        int rooml = 0;
        if (L)
            rooml = L->sz;
        Merge(root, L, R);
        Split(root, L, R, r);
        int roomr = 0;
        if (L)
            roomr = L->sz;
        Merge(root, L, R);
        if (rooml == roomr && rooml % 2 == 1)
            return true;
        else return false;
    }
};

Treap T;
long long t[maxn];

void update(int i, int l, int r, int pos, int add){
    if (l == r){
        t[i] += (long long) add;
        return;
    }
    int mid = (l + r) / 2;
    if (pos <= mid)
        update(i * 2, l, mid, pos, add);
    else update(i * 2, mid + 1, r, pos, add);
    t[i] = max(t[i * 2], t[i * 2 + 1]);
}

long long query(int i, int l, int r, int ql, int qr){
    assert(l <= r);
    assert(ql <= qr);
    if (r < ql || qr < l)
        return 0;
    if (ql <= l && r <= qr){
        if (T.is_even_room(l, r))
            return 0;
        if (T.is_odd_room(l, r))
            return t[i];
    }
    int mid = (l + r) / 2;
    long long rez1 = query(i * 2, l , mid, ql, qr);
    long long rez2 = query(i * 2 + 1, mid + 1, r, ql, qr);
    return rez1 + rez2;
}

void speed(){
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
}

int main()
{
    rg.seed(time(0));
	speed();
	cin >> n >> q;
	for (int qi = 0; qi < q; ++qi){
        int t;
        cin >> t;
        if (t == 1){
            int p;
            cin >> p;
            T.Insert(p);
        }
        else if (t == 2){
            int p;
            cin >> p;
            T.Remove(p);
        }
        else if (t == 3){
            int c, add;
            cin >> c >> add;
            //part[c] += add;
            update(1, 1, n, c, add);
        }
        else if (t == 4){
            int l, r;
            cin >> l >> r;
            cout << query(1, 1, n, l, r);
        }
	}
	return 0;
}
/*
10 20
1 4
3 3 7
3 4 1
3 5 8
3 6 5
4 3 6
1 1
4 3 6
3 10 3
3 9 2
3 8 9
1 8
4 1 10
4 4 9
3 9 8
1 7
3 2 6
4 2 9
2 1
4 2 9
*/
