#include <iostream>
#include <vector>

#define maxn 5005

using namespace std;

int n , m;

vector <int> v[maxn];

vector<char> color;

vector<int> parent;
int cycle_start, cycle_end;

void read()
{
    cin >> n >> m;

    int from , to;
    for(int i = 0; i < m; i++)
    {
        cin >> from >> to;
        v[from].push_back(to);
    }
}

bool dfs(int node)
{
    color[node] = 1;
    for (int u : v[node])
    {
        if (color[u] == 0)
        {
            parent[u] = node;
            if (dfs(u)) return true;
        }
        else if (color[u] == 1)
        {
            cycle_end = node;
            cycle_start = u; 
            return true;
        }
    }
    color[node] = 2;
    return false;
}

void find_cycle()
{
    color.assign(n, 0);
    parent.assign(n, -1);
    cycle_start = -1;

    for (int v = 0; v < n; v++) if (color[v] == 0 && dfs(v)) break;

    if (cycle_start == -1)
    {
        cout << 0 << endl;
    }
    else
    {
        cout << 1 << endl;
    }
}

int main()
{

    read();
    find_cycle();

    return 0;

}
