#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

struct edge
{
    int ver, dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

const int maxn = 5005;

int n,m;
unsigned int d[maxn], inf = -1;
vector<int>g[maxn];
vector<edge>v[maxn];
vector<pair<int,int> >sp;
int ind,used[maxn];
bool cycle;
int ai,bi;

void read()
{
    cin >> n >> m;
    int x,y;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y;
        sp.push_back(make_pair(x,y));
        g[x].push_back(y);
        v[x].push_back({y,0});
        v[y].push_back({x,1});
    }
}

void dfs(int beg)
{
    used[beg] = 1;
    for(int nb:g[beg])
    {
        if(used[nb]==1) cycle = true;
        if(!used[nb]) dfs(nb);
    }
    used[beg] = 2;
}

void dijkstra(int s)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[s] = 0;
    q.push({s,0});
    while(!q.empty())
    {
        edge e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            for(edge nb:v[e.ver])
            {
                if((!((nb.ver==ai&&e.ver==bi)||(nb.ver==bi&&e.ver==ai)))&&nb.dist+e.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}

void solve()
{
    cycle = false;
    for(int i=1;i<=n;i++)
    {
        memset(used,0,sizeof(used));
        dfs(i);
    }
    if(cycle)
    {
        cout << 0 << endl;
        exit(0);
    }
    int ans = m+1;
    for(int i=0;i<sp.size();i++)
    {
        ai = sp[i].first;
        bi = sp[i].second;
        dijkstra(bi);
        if(d[ai]!=inf)
        {
            /*cout << ai << " " << bi << " " << d[ai] << endl;
            for(int j=1;j<=n;j++) cout << d[j] << " ";
            cout << endl;*/
            ans = min(ans,(int)d[ai]);
        }
        dijkstra(ai);
        if(d[bi]!=inf)
        {
            /*cout << ai << " " << bi << " " << d[bi]+1 << endl;
            for(int j=1;j<=n;j++) cout << d[j] << " ";
            cout << endl;*/
            ans = min(ans,(int)d[bi] + 1);
        }
    }
    if(ans==m+1) ans = -1;
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
